## ddm 0.1.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.25.0)

project(DDM
    VERSION 0.2.2
    LANGUAGES CXX C)

set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)
set(CMAKE_AUTOMOC ON)
set(CMAKE_AUTORCC ON)
SET(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)

# Set version
set(DDM_VERSION_MAJOR 0)
set(DDM_VERSION_MINOR 20)
set(DDM_VERSION_PATCH 0)
set(DDM_VERSION_STRING "${DDM_VERSION_MAJOR}.${DDM_VERSION_MINOR}.${DDM_VERSION_PATCH}")
add_compile_definitions("DDM_VERSION=\"${DDM_VERSION_STRING}\"")

# Standard installation paths
include(GNUInstallDirs)
# Macros
include(FeatureSummary)

# Options
option(BUILD_MAN_PAGES "Build man pages" OFF)
option(ENABLE_JOURNALD "Enable logging to journald" ON)
option(NO_SYSTEMD "Disable systemd support" OFF)
option(USE_ELOGIND "Use elogind instead of logind" OFF)

set(CMAKE_CXX_STANDARD 20)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_EXPORT_COMPILE_COMMANDS ON)

# ECM
find_package(ECM 1.4.0 REQUIRED NO_MODULE)
set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake;${CMAKE_MODULE_PATH};${ECM_MODULE_PATH}")

# Definitions
add_definitions(-Wall -Wextra)

# Default build type
if(NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE Release)
endif()

# Handle build type
if(CMAKE_BUILD_TYPE MATCHES [Dd]ebug)
    message(STATUS "Debug build")
    add_definitions(-DDEBUG)
else()
    message(STATUS "Release build")
    add_definitions(-DNDEBUG)
endif()

# Default absolute paths
if(NOT DEFINED CMAKE_INSTALL_SYSCONFDIR)
    set(CMAKE_INSTALL_SYSCONFDIR "/etc")
endif()
if(NOT DEFINED CMAKE_INSTALL_LOCALSTATEDIR)
    set(CMAKE_INSTALL_LOCALSTATEDIR "/var")
endif()

# PKG-CONFIG
find_package(PkgConfig)

# PAM
find_package(PAM REQUIRED)

# XAU
pkg_check_modules(LIBXAU REQUIRED "xau")

# XCB
find_package(XCB REQUIRED)

# XKB
find_package(XKB REQUIRED)

find_package(Qt6 CONFIG REQUIRED Core DBus Gui Qml Quick QuickControls2 LinguistTools Test QuickTest)
qt_standard_project_setup(REQUIRES 6.6)

# Uninstall target
if ("${ECM_VERSION}" VERSION_LESS "1.7.0")
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
                   IMMEDIATE @ONLY)
    add_custom_target(uninstall COMMAND ${CMAKE_COMMAND} -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")
endif()

# systemd
if(NOT NO_SYSTEMD AND NOT USE_ELOGIND)
    pkg_check_modules(SYSTEMD "systemd")
endif()

if(SYSTEMD_FOUND)
    add_definitions(-DHAVE_SYSTEMD)
    set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_SYSTEMD)

    # libsystemd-journal was merged into libsystemd in 209
    if(${SYSTEMD_VERSION} VERSION_LESS 209)
        pkg_check_modules(JOURNALD "libsystemd-journal")
    else()
        pkg_check_modules(JOURNALD "libsystemd")
    endif()

    if(ENABLE_JOURNALD)
        if(JOURNALD_FOUND)
            add_definitions(-DHAVE_JOURNALD)
            set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_JOURNALD)
        else()
            message(WARNING "Disable journald support for lack of libsystemd-journal")
        endif()
    endif()

    if (NOT DEFINED SYSTEMD_SYSTEM_UNIT_DIR)
        pkg_get_variable(SYSTEMD_SYSTEM_UNIT_DIR systemd systemdsystemunitdir)
    endif()

    if (NOT DEFINED SYSTEMD_SYSUSERS_DIR)
        pkg_get_variable(SYSTEMD_SYSUSERS_DIR systemd sysusersdir)
    endif()

    if (NOT DEFINED SYSTEMD_TMPFILES_DIR)
        pkg_get_variable(SYSTEMD_TMPFILES_DIR systemd tmpfilesdir)
    endif()

    set(HALT_COMMAND "/usr/bin/systemctl poweroff")
    set(REBOOT_COMMAND "/usr/bin/systemctl reboot")
else()
    set(SYSTEMD_FOUND 0)
endif()
add_feature_info("systemd" SYSTEMD_FOUND "systemd support")
add_feature_info("journald" JOURNALD_FOUND "journald support")

# elogind
if(NO_SYSTEMD AND USE_ELOGIND)
    pkg_check_modules(ELOGIND "libelogind")
endif()

if(ELOGIND_FOUND)
    add_definitions(-DHAVE_ELOGIND)
    set(CMAKE_AUTOMOC_MOC_OPTIONS -DHAVE_ELOGIND)

    set(HALT_COMMAND "/usr/bin/loginctl poweroff")
    set(REBOOT_COMMAND "/usr/bin/loginctl reboot")
endif()
add_feature_info("elogind" ELOGIND_FOUND "elogind support")

# Default behaviour if neither systemd nor elogind is used
if (NOT ELOGIND_FOUND AND NOT SYSTEMD_FOUND)
    # Set the VT on which ddm will normally appear, and the
    # commands for shutdown and reboot. On FreeBSD, there are
    # normally more getty's running than on Linux.
    if("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
        set(HALT_COMMAND "/sbin/shutdown -p now")
    else()
        set(HALT_COMMAND "/sbin/shutdown -h -P now")
    endif()
    set(REBOOT_COMMAND "/sbin/shutdown -r now")
endif()

if (SYSTEMD_FOUND)
    set(RUNTIME_DIR_DEFAULT "/run/ddm")
else()
    set(RUNTIME_DIR_DEFAULT "${CMAKE_INSTALL_LOCALSTATEDIR}/run/ddm")
endif()

# Set constants
set(DATA_INSTALL_DIR            "${CMAKE_INSTALL_FULL_DATADIR}/ddm"                CACHE PATH      "System application data install directory")
set(DBUS_CONFIG_DIR             "${CMAKE_INSTALL_FULL_SYSCONFDIR}/dbus-1/system.d"       CACHE PATH      "DBus config files directory")
set(STATE_DIR                   "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/lib/ddm"      CACHE PATH      "State directory")
set(RUNTIME_DIR                 "${RUNTIME_DIR_DEFAULT}"                            CACHE PATH      "Runtime data storage directory")
set(QML_INSTALL_DIR             "${QT_IMPORTS_DIR}"                                 CACHE PATH      "QML component installation directory")

set(SESSION_COMMAND             "${DATA_INSTALL_DIR}/scripts/Xsession"              CACHE PATH      "Script to execute when starting the X11 desktop session")
set(WAYLAND_SESSION_COMMAND     "${DATA_INSTALL_DIR}/scripts/wayland-session"       CACHE PATH      "Script to execute when starting the Wayland desktop session")

set(CONFIG_FILE                 "${CMAKE_INSTALL_FULL_SYSCONFDIR}/ddm.conf"        CACHE PATH      "Path of the ddm config file")
set(CONFIG_DIR                  "${CMAKE_INSTALL_FULL_SYSCONFDIR}/ddm.conf.d"      CACHE PATH      "Path of the ddm config directory")
set(ACCOUNTSSERVICE_DATA_DIR    "/var/lib/AccountsService"                          CACHE PATH      "Path of the accountsservice data directory")
set(SYSTEM_CONFIG_DIR           "${CMAKE_INSTALL_PREFIX}/lib/ddm/ddm.conf.d"      CACHE PATH      "Path of the system ddm config directory")
set(LOG_FILE                    "${CMAKE_INSTALL_FULL_LOCALSTATEDIR}/log/ddm.log"  CACHE PATH      "Path of the ddm log file")
set(DBUS_CONFIG_FILENAME        "org.freedesktop.DisplayManager.conf"               CACHE STRING    "Name of the ddm config file")
set(COMPONENTS_TRANSLATION_DIR  "${DATA_INSTALL_DIR}/translations"                  CACHE PATH      "Components translations directory")
set(DDM_INITIAL_VT             "1"                                                 CACHE STRING    "Initial tty to use")


# Autodetect UID_MIN and UID_MAX from /etc/login.defs
if(NOT DEFINED LOGIN_DEFS_PATH)
    set(LOGIN_DEFS_PATH "/etc/login.defs" CACHE PATH "Path to login.defs")
endif()

if(NOT EXISTS "${LOGIN_DEFS_PATH}" AND NOT DEFINED UID_MIN AND NOT DEFINED UID_MAX)
    message(FATAL_ERROR "Could not find login.defs at ${LOGIN_DEFS_PATH}. Try -DLOGIN_DEFS_PATH.")
endif()

if(NOT DEFINED UID_MIN)
    file(STRINGS "${LOGIN_DEFS_PATH}" UID_MIN LIMIT_COUNT 1 REGEX "^UID_MIN")
    string(REGEX REPLACE "^UID_MIN[\t ]+([0-9]+)" "\\1" UID_MIN "${UID_MIN}")
    if(NOT UID_MIN MATCHES "[0-9]+")
        message(WARNING "Could not detect a valid UID_MIN (got '${UID_MIN}'). You should review your login.defs file.")
        set(UID_MIN 1000)
    else()
        message(STATUS "Autodetected UID_MIN=${UID_MIN} from ${LOGIN_DEFS_PATH}")
    endif()
endif()

if(NOT DEFINED UID_MAX)
    file(STRINGS "${LOGIN_DEFS_PATH}" UID_MAX LIMIT_COUNT 1 REGEX "^UID_MAX")
    string(REGEX REPLACE "^UID_MAX[\t ]+([0-9]+)" "\\1" UID_MAX "${UID_MAX}")
    if(NOT UID_MAX MATCHES "[0-9]+")
        message(WARNING "Could not detect a valid UID_MAX (got '${UID_MAX}'). You should review your login.defs file.")
        set(UID_MAX 65000)
    else()
        message(STATUS "Autodetected UID_MAX=${UID_MAX} from ${LOGIN_DEFS_PATH}")
    endif()
endif()

# Add subdirectories
add_subdirectory(data)
add_subdirectory(services)
add_subdirectory(src)

# enable_testing()
# add_subdirectory(test)

# Display feature summary
feature_summary(WHAT ALL FATAL_ON_MISSING_REQUIRED_PACKAGES)

# CMAKE MODULE
include(CMakePackageConfigHelpers)
configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/data/DDMConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/data/DDMConfig.cmake"
    INSTALL_DESTINATION lib/cmake/DDM
    PATH_VARS CMAKE_INSTALL_PREFIX
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/data/AuthConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/data/AuthConfig.cmake"
    INSTALL_DESTINATION lib/cmake/DDM
    PATH_VARS CMAKE_INSTALL_PREFIX
)

configure_package_config_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/data/CommonConfig.cmake.in"
    "${CMAKE_CURRENT_BINARY_DIR}/data/CommonConfig.cmake"
    INSTALL_DESTINATION lib/cmake/DDM
    PATH_VARS CMAKE_INSTALL_PREFIX
)

install(
    FILES
        "${CMAKE_CURRENT_BINARY_DIR}/data/DDMConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/data/AuthConfig.cmake"
        "${CMAKE_CURRENT_BINARY_DIR}/data/CommonConfig.cmake"
    DESTINATION lib/cmake/DDM
)

=== data/CMakeLists.txt ===
install(DIRECTORY "flags" DESTINATION "${DATA_INSTALL_DIR}")

install(FILES
    "org.freedesktop.DisplayManager.conf"
    DESTINATION "${DBUS_CONFIG_DIR}"
    RENAME ${DBUS_CONFIG_FILENAME}
)

install(FILES
    "faces/root.face.icon.png"
    DESTINATION "${DATA_INSTALL_DIR}/faces"
    RENAME "root.face.icon"
)

install(FILES
    "faces/default.face.icon.png"
    DESTINATION "${DATA_INSTALL_DIR}/faces"
    RENAME ".face.icon"
)

install(FILES
    "scripts/Xsession"
    "scripts/Xsetup"
    "scripts/Xstop"
    "scripts/wayland-session"
    DESTINATION "${DATA_INSTALL_DIR}/scripts"
    PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE
)

if(BUILD_MAN_PAGES)
    add_subdirectory(man)
endif()

=== src/auth/CMakeLists.txt ===
set(PUBLIC_HEADERS
    ${CMAKE_SOURCE_DIR}/src/auth/Auth.h
    ${CMAKE_SOURCE_DIR}/src/auth/AuthMessages.h
    ${CMAKE_SOURCE_DIR}/src/auth/AuthPrompt.h
    ${CMAKE_SOURCE_DIR}/src/auth/AuthRequest.h
)

set(SRCS
    ${CMAKE_SOURCE_DIR}/src/auth/Auth.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthPrompt.cpp
    ${CMAKE_SOURCE_DIR}/src/auth/AuthRequest.cpp
)

add_library(auth SHARED ${PUBLIC_HEADERS} ${SRCS})

set_target_properties(auth PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    OUTPUT_NAME ddm-auth
    EXPORT_NAME Auth
)

target_link_libraries(auth
    PUBLIC
        common
        Qt${QT_MAJOR_VERSION}::Network
        Qt${QT_MAJOR_VERSION}::Qml
)

target_include_directories(auth INTERFACE
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/auth>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/ddm/auth>
)
target_link_directories(auth INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_LIBDIR}>
)

if(PAM_FOUND)
    target_link_libraries(auth PRIVATE ${PAM_LIBRARIES})
else()
    target_link_libraries(auth PRIVATE crypt)
endif()

# 安装库和头文件
install(
    TARGETS auth
    EXPORT AuthTargets
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin
    INCLUDES DESTINATION include/ddm/auth
)

install(FILES ${PUBLIC_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ddm/auth")

# 导出目标文件
install(EXPORT AuthTargets
        FILE AuthTargets.cmake
        NAMESPACE DDM::
        DESTINATION lib/cmake/DDM
)

=== src/common/CMakeLists.txt ===
configure_file("Constants.h.in" "Constants.h" IMMEDIATE @ONLY)
set(PUBLIC_HEADERS
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.h
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.h
    ${CMAKE_SOURCE_DIR}/src/common/MessageHandler.h
    ${CMAKE_SOURCE_DIR}/src/common/Messages.h
    ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.h
    ${CMAKE_SOURCE_DIR}/src/common/Session.h
    ${CMAKE_SOURCE_DIR}/src/common/SignalHandler.h
    ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.h
    ${CMAKE_SOURCE_DIR}/src/common/ThemeConfig.h
    ${CMAKE_SOURCE_DIR}/src/common/ThemeMetadata.h
    ${CMAKE_SOURCE_DIR}/src/common/VirtualTerminal.h
    ${CMAKE_SOURCE_DIR}/src/common/XAuth.h
    ${CMAKE_BINARY_DIR}/src/common/Constants.h
    ${CMAKE_SOURCE_DIR}/src/common/LogindDBusTypes.h
)

set(SRCS
    ${CMAKE_SOURCE_DIR}/src/common/ConfigReader.cpp
    ${CMAKE_SOURCE_DIR}/src/common/Configuration.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SafeDataStream.cpp
    ${CMAKE_SOURCE_DIR}/src/common/Session.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SignalHandler.cpp
    ${CMAKE_SOURCE_DIR}/src/common/SocketWriter.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ThemeConfig.cpp
    ${CMAKE_SOURCE_DIR}/src/common/ThemeMetadata.cpp
    ${CMAKE_SOURCE_DIR}/src/common/VirtualTerminal.cpp
    ${CMAKE_SOURCE_DIR}/src/common/XAuth.cpp
    ${CMAKE_SOURCE_DIR}/src/common/LogindDBusTypes.cpp
)

add_library(common SHARED ${PUBLIC_HEADERS} ${SRCS})

set_target_properties(common PROPERTIES
    VERSION ${CMAKE_PROJECT_VERSION}
    SOVERSION ${CMAKE_PROJECT_VERSION_MAJOR}
    OUTPUT_NAME ddm-common
    EXPORT_NAME Common
)

target_link_libraries(common
    PRIVATE
        Qt${QT_MAJOR_VERSION}::DBus
        Qt${QT_MAJOR_VERSION}::Network
        Qt${QT_MAJOR_VERSION}::Qml
        ${LIBXAU_LINK_LIBRARIES}
)

target_include_directories(common INTERFACE
    $<BUILD_INTERFACE:${CMAKE_SOURCE_DIR}/src/common>
    $<BUILD_INTERFACE:${CMAKE_BINARY_DIR}/src/common>
    $<BUILD_INTERFACE:${CMAKE_CURRENT_LIST_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/ddm/common>
)

target_link_directories(common INTERFACE
    $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
    $<INSTALL_INTERFACE:${CMAKE_INSTALL_LIBDIR}>
)

install(
    TARGETS common
    EXPORT CommonTargets
    ARCHIVE DESTINATION lib
    LIBRARY DESTINATION lib
    RUNTIME DESTINATION bin
    INCLUDES DESTINATION include/ddm/common
)

install(FILES ${PUBLIC_HEADERS} DESTINATION "${CMAKE_INSTALL_INCLUDEDIR}/ddm/common")

install(EXPORT CommonTargets
        FILE CommonTargets.cmake
        NAMESPACE DDM::
        DESTINATION lib/cmake/DDM
)

=== debian/changelog ===
ddm (0.1.1) unstable; urgency=medium

  * fix some bugs

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 27 Jun 2024 14:47:00 +0800

ddm (0.1.0) unstable; urgency=medium

  * Initial release

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Tue, 12 Dec 2023 13:07:40 +0800

## ddm 0.1.3

=== src/daemon/CMakeLists.txt ===
include_directories(
    ${LIBXAU_INCLUDE_DIRS}
    "${LIBXCB_INCLUDE_DIR}"
)

configure_file(config.h.in config.h IMMEDIATE @ONLY)
set(DAEMON_SOURCES
    DaemonApp.cpp
    Display.cpp
    DisplayManager.cpp
    DisplayServer.cpp
    Greeter.cpp
    PowerManager.cpp
    Seat.cpp
    SeatManager.cpp
    SocketServer.cpp
    XorgDisplayServer.cpp
    XorgUserDisplayServer.cpp
    XorgUserDisplayServer.h
    WaylandDisplayServer.cpp
    WaylandDisplayServer.h
    SingleWaylandDisplayServer.h
    SingleWaylandDisplayServer.cpp
)

qt_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.xml"          "DisplayManager.h" DDM::DisplayManager)
qt_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.Seat.xml"     "DisplayManager.h" DDM::DisplayManagerSeat)
qt_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.Session.xml"  "DisplayManager.h" DDM::DisplayManagerSession)

set_source_files_properties("${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Manager.xml" PROPERTIES
   INCLUDE "LogindDBusTypes.h"
)
set_source_files_properties("${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Seat.xml" PROPERTIES
   INCLUDE "LogindDBusTypes.h"
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Session.xml" PROPERTIES
   INCLUDE "LogindDBusTypes.h"
)

set_source_files_properties("${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.User.xml" PROPERTIES
   INCLUDE "LogindDBusTypes.h"
)

qt_add_dbus_interface(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Manager.xml"  "Login1Manager")
qt_add_dbus_interface(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Seat.xml"  "Login1Seat")
qt_add_dbus_interface(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Session.xml"  "Login1Session")
qt_add_dbus_interface(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.User.xml"  "Login1User")

add_executable(ddm ${DAEMON_SOURCES})
target_link_libraries(ddm
    PRIVATE
        auth
    PUBLIC
        Qt${QT_MAJOR_VERSION}::DBus
        Qt${QT_MAJOR_VERSION}::Network
        Qt${QT_MAJOR_VERSION}::Qml
        ${LIBXCB_LIBRARIES}
)

if(JOURNALD_FOUND)
    target_link_libraries(ddm
        PUBLIC
            ${JOURNALD_LIBRARIES}
    )
endif()

install(TARGETS ddm DESTINATION "${CMAKE_INSTALL_BINDIR}")

=== src/helper/CMakeLists.txt ===
include(CheckLibraryExists)

include_directories(
    ${LIBXAU_INCLUDE_DIRS}
)

set(HELPER_SOURCES
    Backend.cpp
    HelperApp.cpp
    UserSession.cpp
    backend/PamHandle.cpp
    backend/PamBackend.cpp
)

add_executable(ddm-helper ${HELPER_SOURCES})
target_link_libraries(ddm-helper
    PRIVATE
        auth
        ${PAM_LIBRARIES}
    PUBLIC
        Qt${QT_MAJOR_VERSION}::Network
        Qt${QT_MAJOR_VERSION}::DBus
        Qt${QT_MAJOR_VERSION}::Qml
)
if("${CMAKE_SYSTEM_NAME}" STREQUAL "FreeBSD")
    # On FreeBSD (possibly other BSDs as well), we want to use
    # setusercontext() to set up the login configuration from login.conf
    find_library(_have_libutil util)
    if(_have_libutil)
        check_library_exists(${_have_libutil} setusercontext "" _have_setusercontext)
    endif()
    if(_have_libutil AND _have_setusercontext)
        target_link_libraries(ddm-helper PUBLIC ${_have_libutil})
    endif()
endif()

install(TARGETS ddm-helper RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

add_executable(ddm-helper-start-wayland HelperStartWayland.cpp waylandsocketwatcher.cpp waylandhelper.cpp)
target_link_libraries(ddm-helper-start-wayland
    PRIVATE
        auth
    PUBLIC
        Qt${QT_MAJOR_VERSION}::Core
)
install(TARGETS ddm-helper-start-wayland RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

add_executable(ddm-helper-start-single-wayland HelperStartSingleMode.cpp singlewaylandhelper.cpp)
target_link_libraries(ddm-helper-start-single-wayland
    PRIVATE
        auth
    PUBLIC
        Qt${QT_MAJOR_VERSION}::Core
)
install(TARGETS ddm-helper-start-single-wayland RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

add_executable(ddm-helper-start-x11user HelperStartX11User.cpp xorguserhelper.cpp)
target_link_libraries(ddm-helper-start-x11user
    PRIVATE
        auth
    PUBLIC
        Qt${QT_MAJOR_VERSION}::Core
)
install(TARGETS ddm-helper-start-x11user RUNTIME DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}")

if(JOURNALD_FOUND)
    target_link_libraries(ddm-helper
        PUBLIC
            ${JOURNALD_LIBRARIES}
    )
    target_link_libraries(ddm-helper-start-x11user
        PUBLIC
            ${JOURNALD_LIBRARIES}
    )
    target_link_libraries(ddm-helper-start-wayland
        PUBLIC
            ${JOURNALD_LIBRARIES}
    )
    target_link_libraries(ddm-helper-start-single-wayland
        PUBLIC
            ${JOURNALD_LIBRARIES}
    )
endif()

=== debian/changelog ===
ddm (0.1.3) unstable; urgency=medium

  * fix C-c will crash

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 6 Sep 2024 11:06:00 +0800

ddm (0.1.2) unstable; urgency=medium

  * fix some bugs

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 25 Jul 2024 17:19:00 +0800

=== debian/control ===
Source: ddm
Priority: optional
Maintainer: justforlxz <zhangdingyuan@deepin.org>
Build-Depends: debhelper-compat (= 13),
               cmake (>= 3.4~),
               pkg-config,
               extra-cmake-modules (>= 1.4.0~),
               libpam0g-dev,
               libsystemd-dev [linux-any],
               libupower-glib-dev,
               libxau-dev,
               libxcb-xkb-dev,
               libxcb1-dev,
               libxkbcommon-dev,
               libxcb-ewmh-dev,
               python3-docutils,
               qt6-base-dev (>= 6.6.1~),
               qt6-declarative-dev (>= 6.6.1~),
               qt6-tools-dev,
               qt6-tools-dev-tools (>= 6.6.1~),
               qt6-wayland,
               qt6-wayland-dev,
               qt6-wayland-private-dev,
               systemd [linux-any],
Standards-Version: 4.6.0
Section: libs
Homepage: https://github.com/linuxdeepin/ddm.git
Rules-Requires-Root: no

Package: ddm
Section: libdevel
#Provides: x-display-manager
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends},
         ${misc:Depends},
         qml6-module-qtquick,
         qml6-module-qtquick-controls,
         qml6-module-qtquick-layouts,
         qml6-module-qtqml-workerscript,
         qml6-module-qtquick-templates,
         qml6-module-qtquick-particles,
         qml6-module-qtquick-dialogs,
         qml6-module-qtquick-window,
         qml6-module-qt5compat-graphicaleffects,
         qml6-module-qtquick-effects,
         qml6-module-qt-labs-folderlistmodel,
         adduser,
         seatd,
         qt6-wayland,
         libqt6svg6,
Recommends: libpam-systemd, xwayland
Description: a modern display manager for Wayland sessions aiming to be fast, simple and beautiful.

Package: libddm
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Multi-Arch: same
Description: DDM library
  provide PAM libraries

Package: libddm-dev
Architecture: any
Depends: ${misc:Depends},
         libddm( =${binary:Version}),
         qt6-base-dev
Description: DDM devel library
  provide PAM headers

## ddm 0.1.10

=== CMakeLists.txt ===
--- 
+++ 
@@ -232,21 +232,21 @@
 configure_package_config_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/data/DDMConfig.cmake.in"
     "${CMAKE_CURRENT_BINARY_DIR}/data/DDMConfig.cmake"
-    INSTALL_DESTINATION lib/cmake/DDM
+    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DDM
     PATH_VARS CMAKE_INSTALL_PREFIX
 )
 
 configure_package_config_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/data/AuthConfig.cmake.in"
     "${CMAKE_CURRENT_BINARY_DIR}/data/AuthConfig.cmake"
-    INSTALL_DESTINATION lib/cmake/DDM
+    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}cmake/DDM
     PATH_VARS CMAKE_INSTALL_PREFIX
 )
 
 configure_package_config_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/data/CommonConfig.cmake.in"
     "${CMAKE_CURRENT_BINARY_DIR}/data/CommonConfig.cmake"
-    INSTALL_DESTINATION lib/cmake/DDM
+    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DDM
     PATH_VARS CMAKE_INSTALL_PREFIX
 )
 
@@ -255,5 +255,5 @@
         "${CMAKE_CURRENT_BINARY_DIR}/data/DDMConfig.cmake"
         "${CMAKE_CURRENT_BINARY_DIR}/data/AuthConfig.cmake"
         "${CMAKE_CURRENT_BINARY_DIR}/data/CommonConfig.cmake"
-    DESTINATION lib/cmake/DDM
-)
+    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DDM
+)

=== data/CMakeLists.txt ===
--- 
+++ 
@@ -4,6 +4,11 @@
     "org.freedesktop.DisplayManager.conf"
     DESTINATION "${DBUS_CONFIG_DIR}"
     RENAME ${DBUS_CONFIG_FILENAME}
+)
+
+install(FILES
+    "org.deepin.DisplayManager.conf"
+    DESTINATION "${DBUS_CONFIG_DIR}"
 )
 
 install(FILES
@@ -30,6 +35,8 @@
         WORLD_READ WORLD_EXECUTE
 )
 
+add_subdirectory(systemd)
+
 if(BUILD_MAN_PAGES)
     add_subdirectory(man)
 endif()

=== src/CMakeLists.txt ===
if (QT_KNOWN_POLICY_QTP0001)
    qt_policy(SET QTP0001 NEW)
endif()

add_subdirectory(common)
add_subdirectory(auth)
add_subdirectory(daemon)
add_subdirectory(helper)

=== data/systemd/CMakeLists.txt ===
if (NOT DEFINED SYSTEMD_SYSTEM_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_SYSTEM_UNIT_DIR systemd systemduserunitdir)
endif()

install(FILES override.conf DESTINATION ${SYSTEMD_SYSTEM_UNIT_DIR}/seatd.service.d/)

=== src/auth/CMakeLists.txt ===
--- 
+++ 
@@ -47,8 +47,8 @@
 install(
     TARGETS auth
     EXPORT AuthTargets
-    ARCHIVE DESTINATION lib
-    LIBRARY DESTINATION lib
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     RUNTIME DESTINATION bin
     INCLUDES DESTINATION include/ddm/auth
 )
@@ -59,5 +59,5 @@
 install(EXPORT AuthTargets
         FILE AuthTargets.cmake
         NAMESPACE DDM::
-        DESTINATION lib/cmake/DDM
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DDM
 )

=== src/common/CMakeLists.txt ===
--- 
+++ 
@@ -62,8 +62,8 @@
 install(
     TARGETS common
     EXPORT CommonTargets
-    ARCHIVE DESTINATION lib
-    LIBRARY DESTINATION lib
+    ARCHIVE DESTINATION ${CMAKE_INSTALL_LIBDIR}
+    LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
     RUNTIME DESTINATION bin
     INCLUDES DESTINATION include/ddm/common
 )
@@ -73,5 +73,5 @@
 install(EXPORT CommonTargets
         FILE CommonTargets.cmake
         NAMESPACE DDM::
-        DESTINATION lib/cmake/DDM
+        DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DDM
 )

=== src/daemon/CMakeLists.txt ===
--- 
+++ 
@@ -26,6 +26,7 @@
 qt_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.xml"          "DisplayManager.h" DDM::DisplayManager)
 qt_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.Seat.xml"     "DisplayManager.h" DDM::DisplayManagerSeat)
 qt_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.Session.xml"  "DisplayManager.h" DDM::DisplayManagerSession)
+qt_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.deepin.DisplayManager.xml"  "DisplayManager.h" DDM::DisplayManager dbus_ddm_displaymanager DDMDisplayManagerAdaptor)
 
 set_source_files_properties("${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.login1.Manager.xml" PROPERTIES
    INCLUDE "LogindDBusTypes.h"

=== debian/changelog ===
ddm (0.1.10) unstable; urgency=medium

  * fix dde system user not in video group

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 21 Jan 2025 11:46:00 +0800

ddm (0.1.9) unstable; urgency=medium

  * move treeland to systemd service

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 20 Dec 2024 15:48:00 +0800

ddm (0.1.8) unstable; urgency=medium

  * limit treeland restart to 3

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 13 Dec 2024 10:44:00 +0800

ddm (0.1.7) unstable; urgency=medium

  * fix black screen when user activate session

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 06 Dec 2024 13:52:00 +0800

ddm (0.1.6) unstable; urgency=medium

  * allow user take tty control

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Thu, 05 Dec 2024 20:58:00 +0800

ddm (0.1.5) unstable; urgency=medium

  * active user tty

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 29 Nov 2024 11:23:00 +0800

ddm (0.1.4) unstable; urgency=medium

  * support treeland lockscreen mode

 -- Dingyuan Zhang <zhangdingyuan@uniontech.com>  Fri, 01 Nov 2024 11:06:00 +0800

=== debian/control ===
--- 
+++ 
@@ -7,13 +7,11 @@
                extra-cmake-modules (>= 1.4.0~),
                libpam0g-dev,
                libsystemd-dev [linux-any],
-               libupower-glib-dev,
                libxau-dev,
                libxcb-xkb-dev,
                libxcb1-dev,
                libxkbcommon-dev,
                libxcb-ewmh-dev,
-               python3-docutils,
                qt6-base-dev (>= 6.6.1~),
                qt6-declarative-dev (>= 6.6.1~),
                qt6-tools-dev,

## ddm 0.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,7 +1,7 @@
 cmake_minimum_required(VERSION 3.25.0)
 
 project(DDM
-    VERSION 0.2.2
+    VERSION 0.2.0
     LANGUAGES CXX C)
 
 set(CMAKE_INCLUDE_CURRENT_DIR ON)
@@ -75,6 +75,9 @@
 
 # XKB
 find_package(XKB REQUIRED)
+
+# TreelandProtocols
+find_package(TreelandProtocols 0.5.0  REQUIRED)
 
 find_package(Qt6 CONFIG REQUIRED Core DBus Gui Qml Quick QuickControls2 LinguistTools Test QuickTest)
 qt_standard_project_setup(REQUIRES 6.6)
@@ -229,6 +232,8 @@
 
 # CMAKE MODULE
 include(CMakePackageConfigHelpers)
+
+# Configure main config file
 configure_package_config_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/data/DDMConfig.cmake.in"
     "${CMAKE_CURRENT_BINARY_DIR}/data/DDMConfig.cmake"
@@ -236,13 +241,22 @@
     PATH_VARS CMAKE_INSTALL_PREFIX
 )
 
+# Configure version file
+write_basic_package_version_file(
+    "${CMAKE_CURRENT_BINARY_DIR}/data/DDMConfigVersion.cmake"
+    VERSION ${DDM_VERSION_STRING}
+    COMPATIBILITY SameMajorVersion
+)
+
+# Configure Auth config file
 configure_package_config_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/data/AuthConfig.cmake.in"
     "${CMAKE_CURRENT_BINARY_DIR}/data/AuthConfig.cmake"
-    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}cmake/DDM
+    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DDM
     PATH_VARS CMAKE_INSTALL_PREFIX
 )
 
+# Configure Common config file
 configure_package_config_file(
     "${CMAKE_CURRENT_SOURCE_DIR}/data/CommonConfig.cmake.in"
     "${CMAKE_CURRENT_BINARY_DIR}/data/CommonConfig.cmake"
@@ -250,9 +264,11 @@
     PATH_VARS CMAKE_INSTALL_PREFIX
 )
 
+# Install all config files
 install(
     FILES
         "${CMAKE_CURRENT_BINARY_DIR}/data/DDMConfig.cmake"
+        "${CMAKE_CURRENT_BINARY_DIR}/data/DDMConfigVersion.cmake"
         "${CMAKE_CURRENT_BINARY_DIR}/data/AuthConfig.cmake"
         "${CMAKE_CURRENT_BINARY_DIR}/data/CommonConfig.cmake"
     DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/DDM

=== services/CMakeLists.txt ===
if(SYSTEMD_FOUND)
    configure_file(ddm.service.in ddm.service)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ddm.service" DESTINATION "${SYSTEMD_SYSTEM_UNIT_DIR}")

    configure_file(ddm-sysuser.conf.in ddm-sysuser.conf)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ddm-sysuser.conf" DESTINATION "${SYSTEMD_SYSUSERS_DIR}" RENAME dde.conf)
endif()

# systemd-tmpfiles can be used standalone without other systemd parts
if(DEFINED SYSTEMD_TMPFILES_DIR)
    configure_file(ddm-tmpfiles.conf.in ddm-tmpfiles.conf)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ddm-tmpfiles.conf" DESTINATION "${SYSTEMD_TMPFILES_DIR}" RENAME ddm.conf)
endif()

if(USE_ELOGIND)
    set(LOGIND_PAM_MODULE "pam_elogind.so")
else()
    set(LOGIND_PAM_MODULE "pam_systemd.so")
endif()
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/ddm-greeter.pam.in" "${CMAKE_CURRENT_BINARY_DIR}/ddm-greeter.pam")

if(EXISTS "/etc/debian_version")
    install(FILES debian.ddm-autologin.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME ddm-autologin)
    install(FILES debian.ddm-greeter.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME ddm-greeter)
    install(FILES debian.ddm.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME ddm)
else()
    if(HAVE_PAM_FAILLOCK)
        install(FILES ddm-autologin.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME ddm-autologin)
    else()
        install(FILES ddm-autologin-tally2.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME ddm-autologin)
    endif()

    install(FILES ddm.pam DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME ddm)
    install(FILES "${CMAKE_CURRENT_BINARY_DIR}/ddm-greeter.pam" DESTINATION ${CMAKE_INSTALL_FULL_SYSCONFDIR}/pam.d RENAME ddm-greeter)
endif()

=== data/man/CMakeLists.txt ===
find_program(RST2MAN_EXECUTABLE NAMES rst2man rst2man.py rst2man2 rst2man2.py)
if(NOT RST2MAN_EXECUTABLE)
    message(FATAL "rst2man (python-docutils) is required to build man pages")
endif()

function(BUILD_MAN_PAGE _sources _src _dst)
    configure_file("${CMAKE_CURRENT_SOURCE_DIR}/${_src}.in"
                   "${CMAKE_CURRENT_BINARY_DIR}/${_src}"
                   IMMEDIATE @ONLY)

    add_custom_command(OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_dst}"
                       COMMAND ${RST2MAN_EXECUTABLE} "${CMAKE_CURRENT_BINARY_DIR}/${_src}" "${CMAKE_CURRENT_BINARY_DIR}/${_dst}"
                       DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/${_src}")

    list(APPEND "${_sources}" "${CMAKE_CURRENT_BINARY_DIR}/${_dst}")
    set("${_sources}" "${${_sources}}" PARENT_SCOPE)

    add_custom_target("man_${_src}" ALL DEPENDS "${CMAKE_CURRENT_BINARY_DIR}/${_dst}")
endfunction()

build_man_page(MAN1_OUTPUT "ddm.rst" "ddm.1")
build_man_page(MAN1_OUTPUT "ddm-greeter.rst" "ddm-greeter.1")
build_man_page(MAN5_OUTPUT "ddm.conf.rst" "ddm.conf.5")
build_man_page(MAN5_OUTPUT "ddm-state.conf.rst" "ddm-state.conf.5")

install(FILES ${MAN1_OUTPUT} DESTINATION "${CMAKE_INSTALL_FULL_MANDIR}/man1")
install(FILES ${MAN5_OUTPUT} DESTINATION "${CMAKE_INSTALL_FULL_MANDIR}/man5")

=== data/systemd/CMakeLists.txt ===
if (NOT DEFINED SYSTEMD_SYSTEM_UNIT_DIR)
    find_package(PkgConfig REQUIRED)
    pkg_check_modules(Systemd REQUIRED systemd)
    pkg_get_variable(SYSTEMD_SYSTEM_UNIT_DIR systemd systemduserunitdir)
endif()

=== src/daemon/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,26 @@
 include_directories(
     ${LIBXAU_INCLUDE_DIRS}
     "${LIBXCB_INCLUDE_DIR}"
+)
+
+pkg_search_module(WAYLAND REQUIRED IMPORTED_TARGET wayland-client)
+
+# Generate treeland-ddm protocol files
+set(TREELAND_DDM_HEADER ${CMAKE_CURRENT_BINARY_DIR}/treeland-ddm-v1.h)
+set(TREELAND_DDM_SOURCE ${CMAKE_CURRENT_BINARY_DIR}/treeland-ddm-v1.c)
+
+add_custom_command(
+    OUTPUT ${TREELAND_DDM_HEADER}
+    COMMAND wayland-scanner client-header < ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-ddm-v1.xml > ${TREELAND_DDM_HEADER}
+    DEPENDS ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-ddm-v1.xml
+    COMMENT "Generating treeland-ddm-v1.h"
+)
+
+add_custom_command(
+    OUTPUT ${TREELAND_DDM_SOURCE}
+    COMMAND wayland-scanner private-code < ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-ddm-v1.xml > ${TREELAND_DDM_SOURCE}
+    DEPENDS ${TREELAND_PROTOCOLS_DATA_DIR}/treeland-ddm-v1.xml
+    COMMENT "Generating treeland-ddm-v1.c"
 )
 
 configure_file(config.h.in config.h IMMEDIATE @ONLY)
@@ -14,6 +34,7 @@
     Seat.cpp
     SeatManager.cpp
     SocketServer.cpp
+    TreelandConnector.cpp
     XorgDisplayServer.cpp
     XorgUserDisplayServer.cpp
     XorgUserDisplayServer.h
@@ -21,6 +42,7 @@
     WaylandDisplayServer.h
     SingleWaylandDisplayServer.h
     SingleWaylandDisplayServer.cpp
+    ${TREELAND_DDM_SOURCE}
 )
 
 qt_add_dbus_adaptor(DAEMON_SOURCES "${CMAKE_SOURCE_DIR}/data/interfaces/org.freedesktop.DisplayManager.xml"          "DisplayManager.h" DDM::DisplayManager)
@@ -57,6 +79,7 @@
         Qt${QT_MAJOR_VERSION}::Network
         Qt${QT_MAJOR_VERSION}::Qml
         ${LIBXCB_LIBRARIES}
+        PkgConfig::WAYLAND
 )
 
 if(JOURNALD_FOUND)

=== debian/changelog ===
ddm (0.2.1) unstable; urgency=medium

  * chore: update license configuration to REUSE specification
  * fix: Fix nix build failure & incorrect versioning
  * fix: fix ddm stuck into dead event loop after crash recovery

 -- rewine <luhongxu@uniontech.com>  Thu, 18 Sep 2025 11:41:30 +0800

ddm (0.2.0) unstable; urgency=medium

  * feat: Support VT switching

 -- rewine <luhongxu@uniontech.com>  Thu, 21 Aug 2025 11:43:52 +0800

ddm (0.1.11) unstable; urgency=medium

  * feat: Create a new seatd service for DDE

 -- rewine <luhongxu@uniontech.com>  Thu, 31 Jul 2025 20:03:34 +0800

=== debian/control ===
--- 
+++ 
@@ -19,6 +19,7 @@
                qt6-wayland,
                qt6-wayland-dev,
                qt6-wayland-private-dev,
+               treeland-protocols,
                systemd [linux-any],
 Standards-Version: 4.6.0
 Section: libs

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
#export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed

include /usr/share/dpkg/architecture.mk

DDM_CMAKE_ARGS = -DDBUS_CONFIG_FILENAME="ddm_org.freedesktop.DisplayManager.conf"

ifneq ($(DEB_HOST_ARCH_OS),linux)
  DDM_CMAKE_ARGS += -DNO_SYSTEMD=ON -DENABLE_JOURNALD=OFF
endif

%:
	dh $@


override_dh_auto_configure:
	dh_auto_configure -- ${DDM_CMAKE_ARGS}

override_dh_installsystemd:
# 	dh_installsystemd -pddm --no-start -r ddm.service

override_dh_installinit:
	dh_installinit --noscripts

# execute_after_dh_auto_install:
# 	# not installed, as the Debian version is used instead
# 	rm -f $(CURDIR)/debian/tmp/lib/systemd/system/ddm.service

#execute_after_dh_fixperms-arch:
	# ensure script is marked as executable
	# chmod +x $(CURDIR)/debian/ddm/etc/ddm/Xsession

execute_after_dh_installpam:
	dh_installpam --name=ddm-autologin
	dh_installpam --name=ddm-greeter

## ddm 0.2.3

=== debian/changelog ===
ddm (0.2.3) unstable; urgency=medium

  * feat: connect treeland with Logind session
  * feat: Add logout cleanup

 -- rewine <luhongxu@uniontech.com>  Fri, 14 Nov 2025 11:23:20 +0800

ddm (0.2.2) unstable; urgency=medium

  * feat: Starting sessions other than treeland using ddm

 -- rewine <luhongxu@uniontech.com>  Thu, 30 Oct 2025 13:34:20 +0800

## ddm 2.3.0

=== Makefile ===
#!/usr/bin/make -f

.PHONY: all build clean

all: build

clean:
	# clean i18n
	(cd po && $(MAKE) clean)

build:
	# build i18n
	tx pull -a
	(cd po && $(MAKE))

=== po/Makefile ===
#!/usr/bin/make -f

package=ddm

.PHONY: all build clean update

all: build

# create mo from the po files
%.mo : %.po
	mkdir -p mo/$(subst .po,,$<)/LC_MESSAGES/
	msgfmt $< -o mo/$(subst .po,,$<)/LC_MESSAGES/$(package).mo

# generate all *.mo files
build: update $(patsubst %.po,%.mo,$(wildcard *.po))

clean:
	rm -rf mo
	# html
	(po4a --rm-translations po4a.cfg)
	rm -rf html/translated

# update *.pot and merge updates into *.po files
update:
	# update template.pot
	@ xgettext \
		--keyword=_ \
		--language=Python \
		--output=$(package).pot \
		--package-name=$(package) \
		--package-version='' \
		--from-code=UTF-8 \
		`find .. -wholename ../debian -prune -o -name '*.py' | grep .py` && echo OK
	# get strings from the desktop file
	@ for LAUNCHER in `find .. -name '*.desktop'`; do \
		sed -r \
			-e '/^(Name|Comment|GenericName|Keywords)\[/d' \
			-e 's/^(Comment=|Name=|GenericName=|Keywords=)/_\1/' \
			$$LAUNCHER > $$LAUNCHER.in ; \
		intltool-extract --type=gettext/ini $$LAUNCHER.in ; \
		xgettext \
			--join-existing \
			--keyword=N_:1 \
			--output $(package).pot \
			$$LAUNCHER.in.h ; \
	done && echo OK
	# merge new strings with translations
	@ for POFILE in $(wildcard *.po); do \
		msgmerge --quiet --backup=none --update $$POFILE $(package).pot ; \
	done && echo OK
	# apply desktop file modifications
	@ for LAUNCHER in `find .. -name '*.desktop'`; do \
		intltool-merge --quiet --desktop-style . $$LAUNCHER.in $$LAUNCHER ; \
		rm $$LAUNCHER.in.h $$LAUNCHER.in ; \
	done && echo OK
	
	# html
	@ touch pot/dummy.pot
	@ rm pot/*.pot
	@ html2po -P en pot && echo "HTML pot files created"
	@ msgcat pot/*.pot >> ddm.pot
	@ head -n50 ddm.pot > .tmp && tail -n+51 ddm.pot | sed '/fuzzy/,/X-/d' >> .tmp && mv -f .tmp ddm.pot && echo "Pot files merged"
	@ po4a po4a.cfg && echo "Po files and translations updated"
	# don't ship incomplete translations
	@ n_required=`ls en | wc -l`; \
	for dir in `echo translated/*`; do \
	    n_slides=`ls $$dir | wc -l`; \
	    [ $$n_slides != $$n_required ] && rm -rf $$dir; \
	done >/dev/null || true
	@ echo "Shipped ddm translations (`ls translated | wc -l`):" `ls translated`

=== debian/changelog ===
ddm (2.3.0-0mx150+1) mx; urgency=medium

  * Rebuild for MX-15
  * Fix apt-get options for our version of apt
  * Change to non-native 3.0 quilt package

 -- Timothy E. Harris <maintainer@mepiscommunity.org>  Thu, 15 Sep 2016 13:36:41 -0400

ddm (2.3.0) debian; urgency=low

  * Added Lithuanian language

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 27 Jul 2016 10:05:45 +0200

ddm (2.2.9) debian; urgency=low

  * Updated Broadcom hardware list

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 13 Jul 2016 07:11:00 +0200

ddm (2.2.8) debian; urgency=low

  * Handle --force-yes in /usr/bin/ddm for Stretch

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 08 Jun 2016 11:47:26 +0200

ddm (2.2.7) debian; urgency=low

  * Use open-as-user to open browser as real user

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 01 Jun 2016 18:32:50 +0200

ddm (2.2.6) debian; urgency=low

  * Updated translations

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Tue, 16 Feb 2016 18:00:00 +0100

ddm (2.2.5) debian; urgency=low

  * Flat logo in background information pages

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Fri, 21 Jan 2016 08:00:00 +0100

ddm (2.2.3) debian; urgency=low

  * Updated translations

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Mon, 18 Jan 2016 12:00:00 +0100

ddm (2.2.2) debian; urgency=low

  * Updated translations

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Sat, 19 Dec 2015 11:00:00 +0100

ddm (2.2.1) debian; urgency=low

  * Improved language detection of localized HTML files

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Fri, 20 Nov 2015 13:00:00 +0100

ddm (2.2.0) debian; urgency=low

  * Added support for Radeon R and FirePro/Gl series
  * Added support for backports

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Fri, 30 Oct 2015 11:00:00 +0100

ddm (2.1.8) debian; urgency=low

  * Can now find help.html

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 28 Oct 2015 16:00:00 +0100

ddm (2.1.7) debian; urgency=low

  * Updated Broadcom drivers list
  * Use ddm in terminal to install/purge drivers (ddm -h for help)

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 21 Oct 2015 11:00:00 +0100

ddm (2.1.5) debian; urgency=low

  * Updated translations

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Mon, 19 Oct 2015 07:30:00 +0100

ddm (2.1.4) debian; urgency=low

  * Check live session on /lib/live/mount instead of /lib/live

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Tue, 07 Jul 2015 07:30:00 +0100

ddm (2.1.3) debian; urgency=low

  * Solved bug not recognizing loaded graphics or wireless drivers

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Mon, 25 Jun 2015 12:00:00 +0100

ddm (2.1.2) debian; urgency=low

  * Improved localization handling

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Mon, 22 Jun 2015 12:00:00 +0100

ddm (2.1.1) debian; urgency=low

  * Fixed crash on binary saved log file

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 27 May 2015 18:00:00 +0100

ddm (2.1.0) debian; urgency=low

  * Improved Arabic translation 
  * Added apt-show-versions as a dependency

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 13 May 2015 16:00:00 +0100

ddm (2.0.9) debian; urgency=low

  * Added KCM launcher for System Settings

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Fri, 08 May 2015 17:00:00 +0100

ddm (2.0.8) debian; urgency=low

  * Added X-XFCE-SettingsDialog;X-XFCE-HardwareSettings; to launcher
  * French translation

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 06 May 2015 15:00:00 +0100

ddm (2.0.7) debian; urgency=low

  * Fix gettext bug

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 29 Apr 2015 18:00:00 +0100

ddm (2.0.6) debian; urgency=low

  * Adapt nvidia settings for Bumblebee

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Sun, 22 Feb 2015 18:00:00 +0100

ddm (2.0.5) debian; urgency=low

  * Change automatic python dependencies so that it installs on Wheezy
  * Lowered gtk+ version for Wheezy

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Sat, 21 Feb 2015 13:00:00 +0100

ddm (2.0.4) debian; urgency=low

  * Force reinstall of packages in case of repair
  * Cleanup after Bumblebee installation

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Fri, 20 Feb 2015 10:00:00 +0100

ddm (2.0.3) debian; urgency=low

  * Debugging for older ATI cards
  * Improved graphical card detection

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Mon, 02 Feb 2015 11:00:00 +0100

ddm (2.0.2) debian; urgency=low

  * Improved Bumblebee support

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Tue, 20 Jan 2015 22:00:00 +0100

ddm (2.0.0) debian; urgency=low

  * Total re-write to simplify use and maintenance

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Thu, 18 Dec 2014 13:00:00 +0100

ddm (1.0.8) debian; urgency=low

  * Improved translation handling

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Sun, 02 Nov 2014 11:00:00 +0100

ddm (1.0.7) debian; urgency=low

  * Gtk2 bug solved

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Mon, 04 Oct 2014 12:00:00 +0100

ddm (1.0.6) debian; urgency=low

  * Changed icon handling for Evolvere icon theme

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Fri, 12 Sep 2014 11:00:00 +0100

ddm (1.0.5) debian; urgency=low

  * Moved locale to solydxk-locale

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Thu, 26 May 2014 08:00:00 +0100

ddm (1.0.4) debian; urgency=low

  * Start with gksudo instead of gksu

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Wed, 23 Apr 2014 19:00:00 +0100

ddm (1.0.3) debian; urgency=low

  * Added Russian translation
  * Adapted Dutch translation

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Tue, 01 Apr 2014 18:00:00 +0100

ddm (1.0.1) debian; urgency=low

  * Added Czech translation
  * Adapted Italian translation

 -- Arjen Balfoort <arjenbalfoort@solydxk.com>  Tue, 24 Dec 2013 12:00:00 +0100

ddm (1.0.0) debian; urgency=low

  * Added transition naming for Nvidia packages
  * Optimized speed of command execution
